<?php
/**
 * OrangeHRM is a comprehensive Human Resource Management (HRM) System that captures
 * all the essential functionalities required for any enterprise.
 * Copyright (C) 2006 OrangeHRM Inc., http://www.orangehrm.com
 *
 * OrangeHRM is free software; you can redistribute it and/or modify it under the terms of
 * the GNU General Public License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * OrangeHRM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program;
 * if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 *
 */

if (!defined('PHPUnit_MAIN_METHOD')) {
    define('PHPUnit_MAIN_METHOD', 'common_AllTests::main');
}
set_include_path(get_include_path() . PATH_SEPARATOR . "../../build");


require_once 'PHPUnit/TextUI/TestRunner.php';

require_once 'authorizeTest.php';
require_once 'CommonFunctionsTest.php';
require_once 'LocaleUtilTest.php';
require_once 'UniqueIDGeneratorTest.php';
require_once 'ConfigTest.php';

class common_AllTests
{
    public static function main()
    {
        PHPUnit_TextUI_TestRunner::run(self::suite());
    }

    public static function suite()
    {
        $suite = new PHPUnit_Framework_TestSuite('OrangeHRM common');
        $suite->addTestSuite('authorizeTest');
        $suite->addTestSuite('CommonFunctionsTest');
	$suite->addTestSuite('UniqueIDGeneratorTest');
        $suite->addTestSuite('LocaleUtilTest');
        $suite->addTestSuite('ConfigTest');
        return $suite;
    }
}

if (PHPUnit_MAIN_METHOD == 'common_AllTests::main') {
    common_AllTests::main();
}
?>
